<?php
/**
 * @file
 * A reference type plugin to describe field collections.
 */
$plugin = array(
  'handler' => array(
    'class' => 'reference_table_formatter_entityreference',
  )
);

/**
 * Class reference_table_formatter_field_collection
 */
class reference_table_formatter_entityreference extends reference_table_formatter_base_type {
  /**
   * {@inheritdoc}
   */
  public function get_bundles() {
    // Field collections can only have a single bundle, matching the field name.
    return $this->field['bundles'][$this->entity_name()];
  }

  /**
   * {@inheritdoc}
   */
  public function entity_name() {
    return $this->field['settings']['target_type'];
  }

  /**
   * {@inheritdoc}
   */
  function renderable_properties() {
    $entity_name = $this->entity_name();
    $common_properties = array(
      'node' => array('title'),
      'user' => array('name'),
      'taxonomy_term' => array('name'),
    );
    return isset($common_properties[$entity_name]) ? $common_properties[$entity_name] : array();
  }

  /**
   * {@inheritdoc}
   */
  function load_entity_from_item($item) {
    $loaded_entities = entity_load($this->entity_name(), array($item['target_id']));
    return array_shift($loaded_entities);
  }
}
